﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraBehavior : MonoBehaviour
{
    public Transform Target;
    public Vector3 Offset;
    private Building targetBuilding;
    RaycastHit hit;

    // Start is called before the first frame update
    void Start()
    {
        
    }

    void Update()
    {
        Debug.DrawRay(transform.position, transform.forward * 8);

        if (Physics.Raycast(transform.position, transform.forward, out hit, 8.0f))
        {
            Building building = hit.collider.gameObject.GetComponent<Building>();
            if (building != null && building.CurBuildingState == BuildingState.Show)
            {
                Material mat = building.GetComponent<MeshRenderer>().material;
                SetToTransparent(mat);

                building.SetTransparent(true);
                targetBuilding = building;
            }
            else if (building == null && targetBuilding != null && targetBuilding.CurBuildingState == BuildingState.Hide)
            {
                Material mat = targetBuilding.GetComponent<MeshRenderer>().material;
                SetToOpaque(mat);
                
                targetBuilding.SetTransparent(false);
                targetBuilding = null;
            }
        }
    }

    void LateUpdate()
    {
        transform.position = Offset + Target.position;
    }

    void SetToOpaque(Material mat)
    {
        mat.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.One);
        mat.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.Zero);
        mat.SetInt("_ZWrite", 1);
        mat.DisableKeyword("_ALPHATEST_ON");
        mat.DisableKeyword("_ALPHABLEND_ON");
        mat.DisableKeyword("_ALPHAPREMULTIPLY_ON");
        mat.renderQueue = -1;
    }

    void SetToTransparent(Material mat)
    {
        mat.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.One);
        mat.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);
        mat.SetInt("_ZWrite", 0);
        mat.DisableKeyword("_ALPHATEST_ON");
        mat.DisableKeyword("_ALPHABLEND_ON");
        mat.EnableKeyword("_ALPHAPREMULTIPLY_ON");
        mat.renderQueue = 3000;
    }
}
