﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public enum FileState
{
    NotDownloading,
    OnDownloading,
    FinishDownload
}

public class File : MonoBehaviour
{
    public float CurrentFileSize = 0.0f;
    public float TotalFileSize = 200.0f;
    public FileState CurFileState = FileState.NotDownloading;
    public UnityEvent OnFileDownloaded;
    public float previousDownloadSpeed = 0;

    public void Download(float data)
    {
        if (CurFileState == FileState.FinishDownload) return;

        previousDownloadSpeed = data;
        if (CurrentFileSize == 0.0f) CurFileState = FileState.OnDownloading;
        CurrentFileSize += previousDownloadSpeed;

        if (CurrentFileSize >= TotalFileSize)
        {
            CurrentFileSize = TotalFileSize;
            CurFileState = FileState.FinishDownload;
            OnFileDownloaded.Invoke();
        }
    }

    public float GetNormalizeFileSize()
    {
        return CurrentFileSize / TotalFileSize;
    }
}
