﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UIManager : MonoBehaviour
{

    public GameObject DownloadPanel;
    public GameObject Phone;
    public GameObject PhoneBattery;
    public List<EnterMechanic> BuildingList;

    // Start is called before the first frame update
    void Start()
    {
        //Phone.SetActive(false);
        DownloadPanel.SetActive(false);

        for (int i = 0; i < BuildingList.Count; i++)
        {
            BuildingList[i].OnEnterEvent.AddListener(OnDownloadPanel);
            BuildingList[i].OnExitEvent.AddListener(OffDownloadPanel);
        }
    }

    // Update is called once per frame
    void OnDownloadPanel()
    {
        DownloadPanel.SetActive(true);
        Phone.SetActive(false);
        if (PhoneBattery != null)
        {
            PhoneBattery.SetActive(false);
        }
    }

    void OffDownloadPanel()
    {
        DownloadPanel.SetActive(false);
        Phone.SetActive(true);
        if (PhoneBattery != null)
        {
            PhoneBattery.SetActive(true);
        }
    }

    

}
