﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class WifiImage : MonoBehaviour
{
    public Transform Buildings;
    public List<Sprite> WifiSprites;
    public int IndexStored = 0;

    private List<Wifi> wifiList = new List<Wifi>();
    private Image image;
    
    // Start is called before the first frame update
    void Start()
    {
        image = GetComponent<Image>();
        GetBuilding();
        foreach (var item in wifiList)
        {
            item.OnFirstBarEnter.AddListener(SetSprite);
            item.OnSecondBarEnter.AddListener(SetSprite);
            item.OnThirdBarEnter.AddListener(SetSprite);
            item.OnForthBarEnter.AddListener(SetSprite);
            item.OnFifthBarEnter.AddListener(SetSprite);

            item.GetComponent<EnterMechanic>().OnExitEvent.AddListener(Reset);
        }
    }

    void GetBuilding()
    {
        foreach (Transform item in Buildings)
        {
            Wifi wifi = item.GetComponent<Wifi>();

            if (wifi != null)
            {
                wifiList.Add(wifi);
            }
        }
    }

    void SetSprite()
    {
        int highestIndex = 0;

        foreach (var item in wifiList)
        {
            if(highestIndex < item.Index)
            {
                highestIndex = item.Index;
            }
        }

        IndexStored = highestIndex;
        image.sprite = WifiSprites[highestIndex];
    }

    void Reset()
    {
        foreach (var item in wifiList)
        {
            if(item.Index == IndexStored)
            {
                wifiList.Remove(item);
                break;
            }
        }

        IndexStored = 0;
        image.sprite = WifiSprites[IndexStored];
    }
}
